"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.validateJson=validateJson,exports.validateManifest=validateManifest,exports.validateProject=validateProject,exports.validateSitemap=validateSitemap,exports.validateSkeleton=validateSkeleton;var _fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_ajv=_interopRequireDefault(require("ajv")),_ajvErrors=_interopRequireDefault(require("ajv-errors")),_manifestSchema=_interopRequireDefault(require("./manifest-schema")),_sharedUtils=require("@hap-toolkit/shared-utils"),_packager=require("@hap-toolkit/packager");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const MAIN_PKG_NAME=_sharedUtils.compileOptionsMeta.MAIN_PKG_NAME,RPKS_SUPPORT_VERSION_FROM=1040;function validateProject(e,o){if(!_fs.default.existsSync(e))throw _sharedUtils.colorconsole.throw(`请确认项目%projectDir%/${o}/下存在manifest.json文件：${e}`),new _sharedUtils.KnownError(`找不到 ${o}/manifest.json`)}const docSrc="https://doc.quickapp.cn/framework/manifest.html";function validateJson(e,o){const t=new _ajv.default({allErrors:!0,jsonPointers:!0});if((0,_ajvErrors.default)(t),t.validate(_manifestSchema.default,e),!t.errors)return[];return t.errors.map((e=>{const t=`校验 ${o} 错误 \n`+e.dataPath.split("/").filter(Boolean).join(".")+e.message+`\n参考: ${docSrc}`;return new Error(t)}))}function validateManifest(e,o,t){validateJson(o,"manifest.json").forEach((e=>{_sharedUtils.colorconsole.error(e.message)}));const{subpackages:s}=o;!t.disableSubpackages&&s&&s.length>0&&validateManifestSubpackages(e,s)}function validateManifestSubpackages(e,o){const t=/^\w+$/,s=/^\w[\w-/]*$/,a=[],r=[],n=_path.default.join(e,"i18n"),l=_path.default.join(e,"lottie"),i=_path.default.join(e,"skeleton");let c="",h="",d="",_=0;o.forEach(((o,f)=>{c=o.name,h=o.resource,d=h&&_path.default.join(e,h),_=f+1,c?t.test(c)?c===MAIN_PKG_NAME?_sharedUtils.colorconsole.throw(`第${_}分包的名字'${c}'是主包保留名，请修改`):a.indexOf(c)>-1?_sharedUtils.colorconsole.throw(`第${_}分包的名字'${c}'已存在，请修改`):a.push(c):_sharedUtils.colorconsole.throw(`第${_}分包的名字'${c}'不合法，只能是数字字母下划线组成，请修改`):_sharedUtils.colorconsole.throw(`第${_}分包的名字不能为空，请添加`),h?s.test(h)?r.indexOf(h)>-1?_sharedUtils.colorconsole.throw(`第${_}分包的资源'${h}'已被使用，请修改`):_fs.default.existsSync(d)?d===n?_sharedUtils.colorconsole.throw(`第${_}分包的资源'${h}'，文件目录'${d}'，i18n文件目录不能作为分包，请修改`):d===l?_sharedUtils.colorconsole.throw(`第${_}分包的资源'${h}'，文件目录'${d}'，lottie文件目录不能作为分包，请修改`):d===i?_sharedUtils.colorconsole.throw(`第${_}分包的资源'${h}'，文件目录'${d}'，骨架屏文件目录不能作为分包，请修改`):function(e,o){for(let t=0,s=r.length;t<s;t++){const s=r[t];if(e.startsWith(s)||s.startsWith(e))return _sharedUtils.colorconsole.throw(`第${o}分包的资源'${e}'与第${t+1}分包的资源'${s}'有包含关系，请修改`),!0}return!1}(h,_)||r.push(h):_sharedUtils.colorconsole.throw(`第${_}分包的资源'${h}'，文件目录'${d}'不存在，请修改`):_sharedUtils.colorconsole.throw(`第${_}分包的资源名'${h}'不合法，只能是 数字字母_ 开头，数字字母_-/ 组成，请修改`):_sharedUtils.colorconsole.throw(`第${_}分包的资源名不能为空，请添加`),o.standalone&&o.icon&&!_fs.default.existsSync(_path.default.join(e,o.icon))&&_sharedUtils.colorconsole.throw(`第${_}分包配置的icon不存在，请修改`),o.standalone&&o.banner&&!_fs.default.existsSync(_path.default.join(e,o.banner))&&_sharedUtils.colorconsole.throw(`第${_}分包配置的banner不存在，请修改`)})),_sharedUtils.colorconsole.warn(`项目已配置分包，若想使用分包功能，请确保平台版本 >= ${RPKS_SUPPORT_VERSION_FROM}`)}function validateSitemap(e,o){const t=_path.default.join(e,"sitemap.json");if(_fs.default.existsSync(t)){const e=require(t).rules,s=Object.keys(o.router.pages||{});e.forEach(((e,o)=>{const t=e.page;return"*"===t||s.includes(t)||_sharedUtils.colorconsole.throw(`sitemap rules第${o+1}项配置错误，该page不存在：${t}`),t}))}}function validateSkeleton(e,o){const t=(0,_packager.getSkeletonConfig)(e),s=o.router.pages||{};if(t){const o=_path.default.join(e,"skeleton/page"),a=t.singleMap||{},r=t.anchorMaps||[];Object.keys(a).forEach((e=>{s[e]||_sharedUtils.colorconsole.throw(`骨架屏singleMap配置页面 ${e} 在manifest上无定义，请检查`);const a=_path.default.join(o,t.singleMap[e]);_fs.default.existsSync(a)||_sharedUtils.colorconsole.throw(`骨架屏singleMap配置页面 ${e} 的sk文件 ${a} 不存在，请检查`)})),Array.isArray(r)||_sharedUtils.colorconsole.throw("骨架屏anchorMaps字段值需为数组，请检查"),r.forEach(((e,t)=>{const{page:a,skeletonMap:r}=e;a||_sharedUtils.colorconsole.throw(`骨架屏anchorMaps第 ${t+1} 配置page值不能为空，请检查`),s[a]||_sharedUtils.colorconsole.throw(`骨架屏anchorMaps第 ${t+1} 配置page值 ${a} 在manifest上无定义，请检查`),Object.keys(r||{}).forEach((e=>{const s=_path.default.join(o,r[e]);_fs.default.existsSync(s)||_sharedUtils.colorconsole.throw(`骨架屏anchorMaps第 ${t+1} 配置锚点 ${e} 的sk文件 ${s} 不存在，请检查`)}))}))}}
//# sourceMappingURL=validate.js.map
